define({"0":{i:0.0310430466931853,u:"../Content/P4Java/about.p4java.html",a:"This guide provides information on installing and using P4Java, and\n      assumes a basic knowledge of both Java (JDK 5 or later) and\nHelix Server. Search Navigation Feedback How can we improve this manual? Email us at\n       manual@perforce.com .\n     Other  documentation See  ...",t:"How to use this guide"},"1":{i:0.0310430466931853,u:"../Content/P4Java/chapter.p4java.html",a:"Perforce Software’s\n      P4Java is a Java API that enables applications to access\nHelix Server,      the Perforce\n      enterprise version control system in a “Java natural” and Java-native\n      way. P4Java presents\n      Helix Server\n      services and\n      managed\n      resources and files as ...",t:"P4Java Programming"},"2":{i:0.0310430466931853,u:"../Content/P4Java/p4java.requirements.html",a:"P4Java assumes the presence of a JDK 6 or later environment, but will\n      work against a JDK 5 installation, with some limitations. Due to current US export control restrictions for some countries, the\n      standard JDK package only comes with 128 bit encryption level cyphers. In\n      order to ...",t:"System Requirements"},"3":{i:0.0310430466931853,u:"../Content/P4Java/p4java.installation.html",a:"Download the P4Java ZIP file from the\n      Perforce\n      web site, extract the enclosed JARs and other files to a temporary\n      directory, then install the p4java.jar JAR file into a\n      location that is suitable for use by compilers, JVMs, and other\n      development tools or applications.",t:"Installation"},"4":{i:0.0310430466931853,u:"../Content/P4Java/p4java.documentation.html",a:"Documentation Included with the P4Java ZIP file is a directory of documentation that\n      contains this document and a full Javadoc document set for all public\n      interfaces and classes. The Javadoc document set can be found at: P4Java API Javadoc",t:"Documentation"},"5":{i:0.0310430466931853,u:"../Content/P4Java/p4java.samples.html",a:"Sample P4Java applications are available in\n      Helix Server’s\n      public depot. To access the public depot, set P4PORT to\n      public.perforce.com:1666 and add the depot path\n      //guest/perforce_software/p4java/samples/basic/... to your\n      client workspace view. These samples are used ...",t:"Sample programs"},"6":{i:0.0310430466931853,u:"../Content/P4Java/p4java.packages.html",a:"The P4Java API contains the following main public packages: com.perforce.p4java: the main P4Java\n\tpackage hierarchy root. Contains a small handful of API-wide\n\tdefinitions and classes for activities like logging, tracing, and\n\tpackage metadata. com.perforce.p4java.server: contains the server ...",t:"Java package roadmap"},"7":{i:0.0310430466931853,u:"../Content/P4Java/p4java.basic.html",a:"The following basic model for P4Java reflects typical\n      Helix Server\n      usage: A Java application uses the P4Java ServerFactory class\n\tto obtain a IServer interface onto a specific Helix Server at a known network address and port, and connects to this Helix Server through the IServer ...",t:"Basic P4Java usage model"},"8":{i:0.0310430466931853,u:"../Content/P4Java/p4java.typical.html",a:"This section briefly describes typical usage patterns and provides a\n      starting point for developers using P4Java for the first time. Many\n      examples below are snippets from (or refer to) the P4Java sample programs\n      available in the\n      Helix Server\n      public depot. To access the ...",t:"Typical usage patterns"},"9":{i:0.0310430466931853,u:"../Content/P4Java/p4java.typical.interfaces.html",a:"The com.perforce.p4java.server.IServer interface represents\n      a specific Helix Server in the P4Java API, with methods to access typical Helix Server services. Each instance of a IServer interface is\n      associated with a Helix Server running at a specified location (network address and port), ...",t:"The IServer and IClient interfaces and\n      the ServerFactory class"},"10":{i:0.0398385765996928,u:"../Content/P4Java/p4java.typical.exceptions.html",a:"P4Java uses a small set of Java exceptions to signal errors that have\n      occurred in either the Helix Server as a result of issuing a specific command to the server, or in the\n      P4Java plumbing in response to things like TCP/IP connection errors or\n      system configuration issues. (These ...",t:"Exception and error handling"},"11":{i:0.0737013639908117,u:"../Content/P4Java/p4java.typical.fileio.html",a:"To define common\n      Helix Server-managed\n      file attributes and options, P4Java uses the\n      com.perforce.p4java.core.file.IFileSpec interface.\n      Attributes like revisions, dates, actions, and so on, are also defined in\n      the core.file package, along with some key helper classes\n     ...",t:"Helix Server file operations"},"12":{i:0.0310430466931853,u:"../Content/P4Java/p4java.typical.summaryvsfull.html",a:"The 2009.2 release of P4Java introduced the notion of “summary” and\n      “full” representations of objects on a Helix Server. In many cases, the Helix Server only returns summaries of objects that it’s been asked to list.\n      For example, if you issue a  p4 clients command to a\n      server, what ...",t:"Summary vs. Full Objects"},"13":{i:0.0310430466931853,u:"../Content/P4Java/p4java.advanced.html",a:"Advanced usage notes The following notes provide guidelines for developers using features\n      beyond the basic usage model.",t:"Advanced usage notes"},"14":{i:0.0310430466931853,u:"../Content/P4Java/p4java.advanced.server.html",a:"P4Java uses a URI string format to specify the network location of\n      target Helix Servers. This URI string format is described in detail in the server\n      factory documentation, but it always includes at least the server’s\n      hostname and port number, and a scheme part that indicates a ...",t:"Helix Server addresses, URIs, and properties"},"15":{i:0.0310430466931853,u:"../Content/P4Java/p4java.advanced.ssl.html",a:"Helix Server\n      at release 2012.1 or higher supports 256-bit SSL connections and trust\n      establishment by accepting the fingerprint of the SSL certificate’s\n      public key. Due to current US export control restrictions for some countries, the\n      standard JDK package only comes with 128 ...",t:"SSL connection support"},"16":{i:0.0310430466931853,u:"../Content/P4Java/p4java.advanced.iserverresource.html",a:"P4Java represents Helix Server objects (such as changelists, branch mappings, job specs, and so\n      on) to the end user through associated interfaces (such as\n      IChangeList, IBranchSpec, and so on) onto\n      objects within P4Java that mirror or proxy the server-side originals.\n      This ...",t:"The IServerResource Interface"},"17":{i:0.0574296364127079,u:"../Content/P4Java/p4java.advanced.properties.html",a:"P4Java uses Java properties to set various operational values for\n      specific IServer instances and/or for P4Java as a whole.\n      These properties are typically used for things like preferred temporary\n      file directory locations, application version and name information for Helix Server ...",t:"P4Java properties"},"18":{i:0.0574296364127079,u:"../Content/P4Java/p4java.advanced.charset.html",a:"Character set support is only enabled for Unicode-enabled Helix Servers. In this mode, P4Java differentiates between\n      Helix Server\n      file content character sets (that is, the encoding used to read or write\n      a file’s contents) and the character sets used for\n      Helix Server\n      ...",t:"Character Set Support"},"19":{i:0.0310430466931853,u:"../Content/P4Java/p4java.advanced.errors.html",a:"Error messages originating from the Helix Server are localized if the Helix Server is localized; error messages originating in P4Java itself are not\n      currently localized. P4Java’s internal error messages aren’t intended for\n      end-user consumption as-is; your applications should process such ...",t:"Error Message Localization"},"20":{i:0.0310430466931853,u:"../Content/P4Java/p4java.advanced.logging.html",a:"P4Java includes a simple logging callback feature, documented in the\n      ILogCallback Javadoc page, that enables consumers to log\n      P4Java-internal errors, warnings, informational messages, exceptions, and\n      so on. Logging is enabled or disabled on a P4Java-wide basis, not on a\n      ...",t:"Logging and tracing"},"21":{i:0.0310430466931853,u:"../Content/P4Java/p4java.advanced.standard_classes.html",a:"The com.perforce.p4java.impl.generic package is the root\n      for a fairly large set of standard implementation classes such as\n      Job, Changelist, and so on. These\n      implementation classes are used internally by P4Java, and\n      while usage is not mandatory, you are encouraged to use them ...",t:"Standard implementation\n      classes"},"22":{i:0.0310430466931853,u:"../Content/P4Java/p4java.advanced.metadata.html",a:"The quality of P4Java’s network and file I/O in real-world usage is\n      strongly affected by the quality of implementation of the underlying Java\n      NIO packages. Java’s handling of file metadata also affects I/O. Although\n      JDK 6 is an improvement over JDK 5, it can be difficult to ...",t:"I/O and file metadata issues"},"23":{i:0.0398385765996928,u:"../Content/P4Java/p4java.advanced.threading.html",a:"P4Java is inherently thread-safe when used properly. The following best\n      practices can help to ensure that users do not encounter thread-related\n      problems: P4Java’s IServer object is partially thread-safe. The\n\tonly state preserved in the underlying implementation classes is the\n\tHelix ...",t:"Threading issues"},"24":{i:0.0798582294274969,u:"../Content/P4Java/p4java.advanced.authentication.html",a:"P4Java implements both the\n      Helix Server\n      tickets-based authentication and the\n      Helix Server\n      single sign on (SSO) feature. Both types of authentication are described\n      in detail in the P4Java Javadoc, but some P4Java-specific issues to note\n      include: P4Java manages a  ...",t:"Authentication"},"25":{i:0.0310430466931853,u:"../Content/P4Java/p4java.advanced.notes.html",a:"As documented in the main\n\tHelix Server\n\tdocumentation,\n\tHelix Server\n\tform triggers can cause additional output on form commands such as\n\t“change” or “client”, even when the trigger succeeds. This trigger\n\toutput is available through the P4Java command callback feature, but\n\tnote that there is ...",t:"Other Notes"},"26":{i:0.0310430466931853,u:"../Content/P4Java/license.statements.html",a:"License Statements Perforce Software includes software developed by the University of\n    California, Berkeley and its contributors. This product includes\n    software developed by the OpenSSL Project for use in the OpenSSL\n    Toolkit ( http://www.openssl.org/ ).\n  ",t:"License Statements"},});